Subject: Re: git push mirror mode V4 (replacement stack)

From: Junio C Hamano <[email-masked]>
Date: Mon, 12 Nov 2007 13:35:42 -0800

Andy Whitcroft <[email-masked]> writes:

> On Fri, Nov 09, 2007 at 11:30:41PM +0000, Andy Whitcroft wrote:
>> Following this mail is a complete replacement git push mirror mode
>> stack (V4).  It folds down all the various patches into a logical
>> sequence (thanks Dscho).  This stack passes the entire test suite,
>> and I have been using the same code for real work here.
>
> Ok, I have spotted one oddity with this feature.  The symbolic refs are
> getting converted to real refs in the mirror.  Generally speaking this
> is the <remote>/HEAD refs but I guess it may be possible to have others.

Currently there is no way to remotely create a symref.

It should be easy to make DAV based http push create a symref
file.

The native "send-pack" protocol does not support such feature,
so this needs a protocol extension, which hopefully would be
not too involved.

Also, to be symmetric, we would need a protocol extension on the
"fetch-pack" protocol side to allow fetchers to find out which
one is a symref pointing out what other ref.  The lack of the
information is why git-clone has to guess.